#include <termios.h>
#include <unistd.h>

//#define DEBUG  // dump debug info

#define TIRA2_SERIAL_PORT  "/dev/ttyUSB0"

#define SEND_BUF_LEN     1024
#define RESPONSE_BUF_LEN 1024
#define IRCODE_BUF_LEN   1024

int
tira_open_serial(const char *serial_port_name,
                 int *fd);

int
tira_init_attribute(const int fd,
                    struct termios *savetty);

int
tira_change_6bytes_mode(const int fd);

int
tira_check_tira2(const int fd);

int
tira_switch2timing_mode(const int fd);

int
tira_capture_IR_code(const int fd,
		     unsigned char *ir_data,
		     int *irdata_length);

int
tira_close_serial(const int fd,
                  struct termios *restore_tty);

int
tira_generate_ircode(unsigned char *cap_data,
		     int cap_data_length,
		     unsigned char *ircode,
		     int *ircode_length);

int
tira_encode_ir_code(unsigned char *cap_data,
                    int cap_data_length,
                    unsigned char *tr_ircode,
                    int *ircode_length);

int
my_compare_func(const void* val1_ptr,
		const void* val2_ptr);

int
tira_transfer_IR_code(const int fd,
		      unsigned char *ircode,
		      int ircode_length);
